package com.tzld.piaoquan.risk.control.service.impl;

import com.tzld.piaoquan.risk.control.config.LoginUserContext;
import com.tzld.piaoquan.risk.control.dao.mapper.UserBaseMapper;
import com.tzld.piaoquan.risk.control.model.dto.Page;
import com.tzld.piaoquan.risk.control.model.dto.WorkWechatUserInfo;
import com.tzld.piaoquan.risk.control.model.po.UserBase;
import com.tzld.piaoquan.risk.control.model.po.UserBaseExample;
import com.tzld.piaoquan.risk.control.service.WorkWechatService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@Service
public class WorkWechatServiceImpl implements WorkWechatService {

    @Autowired
    private UserBaseMapper userBaseMapper;

    @Override
    public Page<WorkWechatUserInfo> findUserInfoList(int pageSize, int currentPage) {

        Page<WorkWechatUserInfo> page = new Page<>();

        UserBaseExample userBaseExample = new UserBaseExample();
        userBaseExample.createCriteria().andCreateUserEqualTo(LoginUserContext.getUserId());

        long total = userBaseMapper.countByExample(userBaseExample);

        userBaseExample.setPage(new Page<UserBase>(currentPage, pageSize));
        List<UserBase> userBases = userBaseMapper.selectByExample(userBaseExample);

        List<WorkWechatUserInfo> workWechatUserInfos = getWorkWechatUserInfos(userBases);

        page.setTotalSize((int) total);
        page.setObjs(workWechatUserInfos);
        page.setCurrentPage(currentPage);
        page.setPageSize(pageSize);
        return page;
    }

    private static List<WorkWechatUserInfo> getWorkWechatUserInfos(List<UserBase> userBases) {
        List<WorkWechatUserInfo> workWechatUserInfos = new ArrayList<>();
        for (UserBase userBase : userBases) {
            WorkWechatUserInfo workWechatUserInfo = new WorkWechatUserInfo();
            workWechatUserInfo.setId(userBase.getId());
            workWechatUserInfo.setUuid(userBase.getUuid());
            workWechatUserInfo.setVid(userBase.getVid());
            workWechatUserInfo.setPhone(userBase.getMobile());
            workWechatUserInfo.setName(userBase.getRealname());
            workWechatUserInfo.setAvatar(userBase.getAvatar());
            workWechatUserInfo.setCorpId(userBase.getCorpId());
            workWechatUserInfo.setCorpName(userBase.getCorpName());
            workWechatUserInfo.setUnionId(userBase.getUnionid());
            workWechatUserInfo.setLoginStatus(userBase.getLoginStatus());
            workWechatUserInfos.add(workWechatUserInfo);
        }
        return workWechatUserInfos;
    }
}
